<template>
  <div class="page-add-food page-add-activity">
    <app-header :sticky="true" />
    <div class="app-body">
      <div class="page-header bg-gradient-primary">
        <h5 class="text-center mb-5 pb-4 mt-4">
          <span>فعالیت های</span>
          <span>{{ dateMoment.format('dddd jDD jMMMM ماه') }}</span>
        </h5>
      </div>
      <div class="the-container">
        <loader :loading="loading" class="meals-list">
          <card-item
            :items="activities"
            :total="todayTotalCalorie"
            @add="adding = true"
            @update="getDayActivities"
          />
        </loader>
      </div>
    </div>
    <add-modal :active.sync="adding" @submit="add" />
  </div>
</template>

<script>
import '../../assets/sass/pages/add-food.scss'
import AddModal from './AddModal'
import CardItem from './CardItem'

export default {
  name: 'AddActivity',
  components: { AddModal, CardItem },
  data() {
    return {
      loading: false,
      loadingProgress: false,

      // save day used calorie
      // the used calorie before we enter to this page
      usedCalorieOld: null,

      adding: false,
      date: ''
    }
  },
  computed: {
    dateMoment() {
      return this.$moment(this.date)
    },
    activities() {
      return this.$store.getters['activity/activities'][this.date] || []
    },
    todayTotalCalorie() {
      let used = this.activities.map(i => i.calorie).reduce((a, b) => a + b, 0)
      // update the usedCalorieOld for first time only
      if (this.usedCalorieOld === null) {
        // eslint-disable-next-line
        this.usedCalorieOld = used
      }
      return used
    }
  },
  created() {
    let date = this.$route.query.date
    if (!date) {
      date = this.$moment().format('YYYY-MM-DD')
    }
    this.date = date
    this.getDayActivities()
  },
  methods: {
    getDayActivities() {
      this.$store.dispatch('activity/getDayActivities', {
        $vm: this,
        $data: {
          date: this.date
        }
      })
    },
    add(data) {
      // close the addFood modal
      this.adding = null

      this.$store.commit('activity/addTemporaryActivity', {
        ...data,
        date: this.date
      })
    }
  },
  beforeRouteLeave(to, from, next) {
    // if added an activity or any changes are made
    // then we will rest the day data from store/home/plans
    if (this.usedCalorieOld !== this.todayTotalCalorie) {
      this.$store.commit('home/resetDay', this.date)
    }
    next()
  }
}
</script>
